# -*- coding: utf-8 -*-
from setuphelpers import *
import platform
import json

uninstallkey = []

latest_bin_deb = 'onlyoffice-desktopeditors_amd64.deb'
latest_bin_rpm = 'onlyoffice-desktopeditors.x86_64.rpm'

def install():

    isapt = True
    try:
        run('apt-get --version')
    except:
        isapt = False

    if isapt:
        install_deb(latest_bin_deb)
    else:
        install_rpm(latest_bin_rpm)

def uninstall():
    uninstall_apt('onlyoffice-desktopeditors')

def update_package():
    print('Update package content from upstream binary sources')

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system()=='Windows' and isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    remove_file('onlyoffice-desktopeditors_amd64.deb')

    # Specific app values
    app_name = control.name
    git_repo = 'ONLYOFFICE/DesktopEditors'
    url_api = 'https://api.github.com/repos/%s/releases/latest' % git_repo

    # Getting latest version from official website
    json_load = json.loads(wgets(url_api,proxies=proxy))
    for download in json_load['assets']:
        if download['name'] == latest_bin_deb:
            url_dl_deb = download['browser_download_url']
            break
    for download in json_load['assets']:
        if download['name'] == latest_bin_rpm:
            url_dl_rpm = download['browser_download_url']
            break

    version = json_load['tag_name'].split('-')[-1]

    # Downloading latest binaries
    if not isfile(latest_bin_deb):
        print('Downloading: ' + latest_bin_deb)
        wget(url_dl_deb,latest_bin_deb,proxies=proxy)

    # Downloading latest binaries
    if not isfile(latest_bin_rpm):
        print('Downloading: ' + latest_bin_deb)
        wget(url_dl_rpm,latest_bin_rpm,proxies=proxy)

	# Changing version of the package
    control.version = '%s-%s'%(version,int(control.version.split('-',1)[1])+1)
    control.save_control_to_wapt()
    print('Changing version to ' + control.version + ' in WAPT\\control')
    print('Update package done. You can now build-upload your package')

